//********************************************************
// Class Slide
// Display a Slide
//
// use jQuery
//********************************************************

var Slide = Class.create( {

    // Public functions ********************************************************

    initialize: function( objectParameter )
    {
        // Param
        this.parent = objectParameter.parent ? objectParameter.parent : document.body;
        this.contentId = objectParameter.contentId;
        this.buttonId = objectParameter.buttonId;
        this.specificContentClass = objectParameter.specificContentClass ? objectParameter.specificContentClass : false;
        this.specificButtonClass = objectParameter.specificButtonClass ? objectParameter.specificButtonClass : false;
        this.timeToSlide = objectParameter.timeToSlide ? objectParameter.timeToSlide : 500;
        this.contentSlide = objectParameter.contentSlide ? objectParameter.contentSlide : false;
        this.contentButton = objectParameter.contentButton;
        this.isIndexToChange = objectParameter.isIndexToChange ? objectParameter.isIndexToChange : false;
        this.zIndex = this.parent.css( "z-index" );

        // Content div
        this.divSlideContent = $( document.createElement( "div" ) );
        this.divSlideContent.attr( {id:this.contentId, class:"containerSlideContent"} );
        if( this.specificContentClass )
            this.divSlideContent.addClass( this.specificContentClass );
        if( this.contentId )
            this.divSlideContent.html( this.contentSlide );
        this.parent.append( this.divSlideContent );

        // Button div
        this.divSlideButton = $( document.createElement( "div" ) );
        this.divSlideButton.attr( {id:this.buttonId} );
        this.divSlideButton.attr( {id:this.buttonId, class:"containerSlideButton"} );
        if( this.specificButtonClass )
            this.divSlideButton.addClass( this.specificButtonClass );
        this.divSlideButton.append( this.contentButton );
        this.divSlideButton.bind( "click", jQuery.proxy( this.onClickButton, this ) );
        this.parent.append( this.divSlideButton );
    },

    getContent: function()
    {
        return this.divSlideContent.html();
    },

    setContent: function( newContent )
    {
        this.divSlideContent.html( newContent );
    },

    isContentVisible: function()
    {
        return (this.divSlideContent.css( "display" ) == "block");
    },

    // public
    onClickButton: function()
    {
        if( this.isIndexToChange )
            if( this.isContentVisible() )
                this.parent.css( "z-index", this.zIndex );
            else
                this.parent.css( "z-index", 100 );

        this.divSlideContent.animate( {width:"toggle"}, this.timeToSlide );
    }
} );
