<%@ page import="com.medias.Context" %>

<script type="text/javascript">
    var InterfaceTemplate = Class.create( {

        initialize: function()
        {
            /** *********** CONTAINERS *********** **/
            this.containerTitle = $( "#title" );
            this.containerTools = $( "#tools" );

            /** *********** VARIABLES *********** **/
            this.isLanguageFr = <%=Context.getLangue(request).equals( "fr" )%>;
            this.path = "<%=request.getContextPath()%>";
            this.webmaster = "<%=Context.getWebmaster(request)%>";
            this.relativePageUri = "<%=Context.getRelativePath( request )%>?<%=request.getQueryString()%>";
            this.jSONUser = <%=Context.getUser( request )%> ? <%=Context.getUser( request )%> : false;
            this.screenWidthLimit = 1336;

            /** ************ CREATE ************ **/
            this.createTitleTools();
            this.createLeftSlides();
            this.updateLogoEther();
        },

        // CREATES ********************************************************
        createTitleTools: function()
        {
            this.containerTitle.addClass( "containerTitle" );
            this.containerTitle.html( interfaceTexts["app.fulltitle"] );

            this.createLogin();
            var mailButton = new ComplexButton( {value:interfaceTexts["data.upload.metadata.contact.mail"], parent:this.containerTools, id:"button_mail", onClick:jQuery.proxy( this.onClickMail, this )} );

            var valueLanguage = interfaceTexts["app.fr"];
            if( this.isLanguageFr )
                valueLanguage = interfaceTexts["app.en"];

            var languageButton = new ComplexButton( {value:valueLanguage, parent:this.containerTools, id:"button_language", onClick:jQuery.proxy( this.onClickLanguage, this )} );
            var homeButton = new ComplexButton( {value:interfaceTexts["app.home"], parent:this.containerTools, id:"button_home", onClick:this.onClickHome} );

            var divSmallLogoEther = $( document.createElement( "div" ) );
            divSmallLogoEther.attr( {id:"smallLogoEther", class:"containerSmallLogoEther"} );
            divSmallLogoEther.append( '<a href="http://ether.ipsl.jussieu.fr" target="help"><img src="resources/images/logo_Ether.jpg" width="40px" height="40px"/></a>' );
            this.containerTools.append( divSmallLogoEther );
        },

        createLogin: function()
        {
            var containerLoginButton = $( "#button_login" );

            if( this.jSONUser )
            {
                var textLogin = this.jSONUser.name + " " + this.jSONUser.firstName;
                if( this.jSONUser.role && this.jSONUser.role == "coordinateur" )
                    textLogin += " (" + interfaceTexts["app.admin"] + ")";

                var loginButton = new ComplexButton( {value:textLogin, parent:this.containerTools, id:"button_login"} );

                $( "#button_login #button_middle #button_text" ).addClass( "containerUserLogout" );

                var loginMiddle = $( "#button_login #button_middle" );
                var divImgLogout = $( document.createElement( "div" ) );
                divImgLogout.addClass( "containerImgLogout" );
                divImgLogout.append( "<img src='resources/images/utils/logout.png' width='15px' height='15px/>" );
                divImgLogout.bind( "click", this.onClickLogout );
                loginMiddle.append( divImgLogout );
            }
            else
            {
                var loginButton = new ComplexButton( {value:interfaceTexts["app.connexion"], parent:this.containerTools, id:"button_login"} );

                var loginMiddle = $( "#button_login #button_middle" );
                loginMiddle.empty();
                loginMiddle.attr( {id:"topnav", class:"topnav complexButton_middle"} );
                var aLogin = $( document.createElement( "a" ) );
                aLogin.attr( {href:"login", class:"signin"} );
                aLogin.html( "<span>" + interfaceTexts["app.connexion"] + "</span>" );
                loginMiddle.append( aLogin );

                $( document ).ready( function()
                {
                    $( ".signin" ).click( function( e )
                    {
                        e.preventDefault();
                        $( "fieldset#signin_menu" ).toggle();
                        $( ".signin" ).toggleClass( "menu-open" );
                    } );

                    $( "fieldset#signin_menu" ).mouseup( function()
                    {
                        return false
                    } );

                    $( document ).mouseup( function( e )
                    {
                        if( $( e.target ).parent( "a.signin" ).length == 0 )
                        {
                            $( ".signin" ).removeClass( "menu-open" );
                            $( "fieldset#signin_menu" ).hide();
                        }
                    } );
                } );

                $( function()
                {
                    $( '#forgot_username_link' ).tipsy( {gravity: 'w'} );
                } );
            }
        },

        createLeftSlides: function()
        {
            var divSlideCredits = new Slide( { contentId:"slideContentCredits", buttonId: "slideCredits", parent:$( "#creditSlide" ), isIndexToChange:true,
                contentButton:"<img src='resources/icons/man_credits.gif' width='50px' height='50px'/><br/>" , contentSlide:"CREDDDDIIITS"} );

            var divSlideMentions = new Slide( { contentId:"slideContentMentions", buttonId: "slideMentions", parent:$( "#mentionSlide" ),specificButtonClass:"containerSlideButtonMentions", isIndexToChange:true,
                contentButton:"<img src='resources/icons/man_mentions_2.png' width='50px' height='50px'/><br/>", contentSlide:"MENTIIIOOONNSS"} );

            var divSlideInfos = new Slide( { contentId:"slideContentInfos", buttonId: "slideInfos", parent:$( "#infoSlide" ), specificButtonClass:"containerSlideButtonInfos", isIndexToChange:true,
                contentButton:"<img src='resources/icons/man_info.gif' width='50px' height='50px'/>", contentSlide:"IINNFFFOOOOSSS"} );
        },

        // EVENTS ********************************************************
        onClickHome: function()
        {
            document.location.href = "index.jsp";
        },

        onClickLogout: function()
        {
            document.location.href = "Disconnect.do";
        },

        onClickLanguage: function()
        {
            if( this.isLanguageFr )
                document.location.href = this.path + "/English.do?requestUri=" + this.relativePageUri;
            else
                document.location.href = this.path + "/French.do?requestUri=" + this.relativePageUri;
        },

        onClickMail: function()
        {
            document.location.href = "mailto:" + this.webmaster + "?subject=[MEGAPOLI]";
        },

        /**
         * This method display a small Ether logo if the screen is too small to contain the big one
         */
        updateLogoEther: function()
        {
            if( this.screenWidthLimit > innerWidth )
            {
                $( "#logoEther" ).hide();
                $( "#linkLogoEther" ).hide();
                $( "#smallLogoEther" ).show();
            }
            else
            {
                $( "#logoEther" ).show();
                $( "#linkLogoEther" ).show();
                $( "#smallLogoEther" ).hide();
            }
        }
    } );

</script>